-- No there is no audio emulation. Just some basic stuff for now so it stop complaining

if not srb2gb then rawset(_G, "srb2gb", {}) end

local emu = srb2gb

-- Sound 1
local NR10 = 0
local NR11 = 0
local NR12 = 0
local NR13 = 0
local NR14 = 0

-- Sound 2
local NR21 = 0
local NR22 = 0
local NR23 = 0
local NR24 = 0

-- Sound 3
local NR30 = 0
local NR31 = 0
local NR32 = 0
local NR33 = 0
local NR34 = 0

-- Control
local NR50 = 0
local NR51 = 0
local NR52 = 0

if not emu.mmioW then emu.mmioW = {} end
if not emu.mmioR then emu.mmioR = {} end

emu.mmioW[0x10] = function(val)
	NR10 = val & 0x7F
end

emu.mmioR[0x10] = function(val)
	return NR10
end

emu.mmioW[0x11] = function(val)
	NR11 = val
end

emu.mmioR[0x11] = function(val)
	return NR11
end

emu.mmioW[0x12] = function(val)
	NR12 = val
end

emu.mmioR[0x12] = function(val)
	return NR12
end

emu.mmioW[0x13] = function(val)
	NR13 = val
end

emu.mmioR[0x13] = function(val)
	return NR13
end

emu.mmioW[0x14] = function(val)
	NR14 = val & 0xC7
end

emu.mmioR[0x14] = function(val)
	return NR14
end

emu.mmioW[0x16] = function(val)
	NR21 = val
end

emu.mmioR[0x16] = function(val)
	return NR21
end

emu.mmioW[0x17] = function(val)
	NR22 = val
end

emu.mmioR[0x17] = function(val)
	return NR22
end

emu.mmioW[0x18] = function(val)
	NR23 = val
end

emu.mmioR[0x18] = function(val)
	return NR23
end

emu.mmioW[0x19] = function(val)
	NR24 = val & 0xC7
end

emu.mmioR[0x19] = function(val)
	return NR24
end

emu.mmioW[0x1A] = function(val)
	NR30 = val&0x80
end

emu.mmioR[0x1A] = function()
	return NR30|0x7F
end

emu.mmioW[0x1B] = function(val)
	NR31 = val
end

emu.mmioR[0x1B] = function()
	return 0xFF
end

emu.mmioW[0x1C] = function(val)
	NR32 = val & 0x60
end

emu.mmioR[0x1C] = function()
	return NR32 & 0x60
end

emu.mmioW[0x1D] = function(val)
	NR33 = val
end

emu.mmioR[0x1D] = function()
	return 0xFF
end

emu.mmioW[0x1E] = function(val)
	NR34 = val & 0xC7
end

emu.mmioR[0x1E] = function()
	return NR34 & 0xC7
end


emu.mmioW[0x24] = function(val)
	NR50 = val
end

emu.mmioR[0x24] = function()
	return NR50
end

emu.mmioW[0x25] = function(val)
	NR51 = val
end

emu.mmioR[0x25] = function()
	return NR51
end

emu.mmioW[0x26] = function(val)
	NR52 = val & 0x8F
end

emu.mmioR[0x26] = function()
	return NR52 & 0x8F
end

emu.apuSaveState = function(f)
	local s = string.char
	f:write(s(NR10))
	f:write(s(NR11))
	f:write(s(NR12))
	f:write(s(NR13))
	f:write(s(NR14))
	
	f:write(s(NR21))
	f:write(s(NR22))
	f:write(s(NR23))
	f:write(s(NR24))
	
	f:write(s(NR30))
	f:write(s(NR31))
	f:write(s(NR32))
	f:write(s(NR33))
	f:write(s(NR34))
	
	-- Put dummy data for Sound 4 and WAVE RAM
	f:write(s(0))
	f:write(s(0))
	f:write(s(0))
	f:write(s(0))
	
	for i = 1, 16 do
		f:write(s(0))
	end
	
	f:write(s(NR50))
	f:write(s(NR51))
	f:write(s(NR52))
end

emu.apuLoadState = function(f)
	local s = string.byte
	local t = f:read(37)
	NR10 = s(t,1)
	NR11 = s(t,2)
	NR12 = s(t,3)
	NR13 = s(t,4)
	NR14 = s(t,5)
	
	NR21 = s(t,6)
	NR22 = s(t,7)
	NR23 = s(t,8)
	NR24 = s(t,9)
	
	NR30 = s(t,10)
	NR31 = s(t,11)
	NR32 = s(t,12)
	NR33 = s(t,13)
	NR34 = s(t,14)
	
	-- Put dummy data for Sound 4 and WAVE RAM
	f:write(s(0))
	f:write(s(0))
	f:write(s(0))
	f:write(s(0))
	
	for i = 1, 16 do
		f:write(s(0))
	end
	
	NR50 = s(t,35)
	NR51 = s(t,36)
	NR52 = s(t,37)
end